<?php if (!defined('HTTP_SERVER')) die('You can not access this file directly!');
/**
  @licence GPL 2005-2010  The osCSS developers - osCSS Open Source E-commerce
  @portion code Copyright (c) 2002 osCommerce
  @package osCSS-2 <www http://www.oscss.org>
  @version 2.1.0
  @date  15/12/10, 10:32
  @author oscim <mail aurelien@oscim.fr> <www http://www.oscim.fr>
  @encode UTF-8
  @class newsletters
*/

class newsletters
  implements ExtModPage, InterfacedTJsonS, InterfaceModule {

  const FILENAME =FILENAME_NEWSLETTERS;
  public static $code;

  public static $action;

  public static $list=array();

  /**
    @p int ID newsletter
  */
  public static $nID;
  /**
    @p obj
  */
  public static $nInfo;
  /**
    @p obj module newsletter
  */
  public static $module;

  public static $uhtml_received_count;
  public static $uhtml_want_count;

  /**
    class constructor
  */
  public function __construct() {
    self::$code=__CLASS__;

    //! active datatable in ajax, precise les GET necessaire
    define('JSONSTATMENT', 'mod=page&type='.self::$code);
    //! detail item in ajax
    define('AJAXSTATMENTDETAIL', 'mod=page&type='.self::$code);
  }

  public function check_action($actions){
    global $messageStack,$oscss;


    self::$action=$actions;
    $DB=Database::getInstance();

    switch (self::$action) {
      case 'lock':
      case 'unlock':
        $newsletter_id = tep_db_prepare_input($_GET['nID']);
        $status = ((self::$action == 'lock') ? '1' : '0');

        $DB->query("update " . TABLE_NEWSLETTERS . " set locked = '" . $status . "' where newsletters_id = '" . (int)$newsletter_id . "'");

        tep_redirect(tep_href_link(self::FILENAME, 'nID=' . $_GET['nID']));
      break;

      case 'insert':
      case 'update':
        if (isset($_POST['newsletter_id'])) $newsletter_id = tep_db_prepare_input($_POST['newsletter_id']);

        $newsletter_module = tep_db_prepare_input($_POST['module']);
        $title = tep_db_prepare_input($_POST['title']);
        $content = tep_db_prepare_input($_POST['content']);

        $newsletter_error = false;
	try {
	  if (empty($title)) throw new Exception (__('error newsletter title'));
	  if (empty($newsletter_module))throw new Exception (__('error newsletter module'));
	} catch (Exception $e) {
	    $messageStack->add($e->getMessage(), 'error');
	    $newsletter_error=true;
	}


	if ($newsletter_error == false) {
	  $sql_data_array = array('title' => $title,
				  'content' => $content,
				  'module' => $newsletter_module);

	  if (self::$action == 'insert') {
	    $sql_data_array['date_added'] = 'now()';
	    $sql_data_array['status'] = '0';
	    $sql_data_array['locked'] = '0';

	    $res=tep_db_perform(TABLE_NEWSLETTERS, $sql_data_array);
	    $newsletter_id = $res->__get('insertId');
	  }
	  elseif (self::$action == 'update') {
	    tep_db_perform(TABLE_NEWSLETTERS, $sql_data_array, 'update', "newsletters_id = '" . (int)$newsletter_id . "'");
	  }

          tep_redirect(tep_href_link(self::FILENAME,  'nID=' . $newsletter_id));
	} else {
	  //! init wisywyg
	  $oscss->_add_ext(BO_WISIWYG_SELECTED,'editeur/');
	  echo $oscss->_call(BO_WISIWYG_SELECTED,'_top','content','800','400');
	}
      break;

      case 'deleteconfirm':
        $newsletter_id = tep_db_prepare_input($_GET['nID']);

         $DB->query("delete from " . TABLE_NEWSLETTERS . " where newsletters_id = '" . (int)$newsletter_id . "'");

        tep_redirect(tep_href_link(self::FILENAME));
      break;


      case 'edit':
      case 'new':

	$parameters = array('title' => '',
			    'content' => '',
			    'module' => '');

	self::$nInfo = new objectInfo($parameters);


    //     $nInfo->objectInfo($_POST);

	//! init wisywyg
	$oscss->_add_ext(BO_WISIWYG_SELECTED,'editeur/');
	echo $oscss->_call(BO_WISIWYG_SELECTED,'_top','content','800','400');

    break;
      case 'send':
      case 'confirm_send':
        $newsletter_id = tep_db_prepare_input($_GET['nID']);

        $check_query =  $DB->query("select locked from " . TABLE_NEWSLETTERS . " where newsletters_id = '" . (int)$newsletter_id . "'");
        $check = $check_query->fetchAssoc();

        if ($check['locked'] < 1) {
          switch ($action) {
            case 'delete': $error = ERROR_REMOVE_UNLOCKED_NEWSLETTER; break;
            case 'new': $error = ERROR_EDIT_UNLOCKED_NEWSLETTER; break;
            case 'send': $error = ERROR_SEND_UNLOCKED_NEWSLETTER; break;
            case 'confirm_send': $error = ERROR_SEND_UNLOCKED_NEWSLETTER; break;
          }

          $messageStack->add_session($error, 'error');

          tep_redirect(tep_href_link(self::FILENAME, 'nID=' . $_GET['nID']));
        }
        break;
    }

    //! alert
    if (!_cst_bool('SEND_EMAILS')) $messageStack->add(ERR_TXT_EMAIL_OFF, 'warning');
    if (!_cst_bool('EMAIL_USE_HTML'))  $messageStack->add(ERR_TXT_EMAIL_TXT_STRICT, 'warning');

    return self::$action;
  }

  public function get_header(){
  }


  public static function load_db_values($ID){
    $DB=Database::getInstance();
    $query_raw ="select newsletters_id, title, content,module, date_added, date_sent, status, locked,nbr_send from " . TABLE_NEWSLETTERS . " where newsletters_id = '" . $ID . "'";
    $_query = $DB->query($query_raw);

    return new objectInfo($_query->fetchAssoc() );
  }


  public function display_view(){
    switch (self::$action) {
      case 'delete':
	self::$nID=(int)$_GET['nID'];
	return tep_get_include_contents(self::$code.'.delete');
      break;
      case 'insert':
      case 'update':
	self::$nID=(int)$_GET['nID'];
	self::$nInfo=new objectInfo($_POST);
	return tep_get_include_contents(self::$code.'.edit');
      break;
      case 'new':
      case 'edit':
	if(isset($_GET['nID'])){
	  self::$nID=(int)$_GET['nID'];
	  self::$nInfo=self::load_db_values(self::$nID);
	}
	return tep_get_include_contents(self::$code.'.edit');
      break;
      case 'preview':
	self::$nID=(int)$_GET['nID'];
	self::$nInfo=self::load_db_values(self::$nID);
	return tep_get_include_contents(self::$code.'.preview');
      break;
      case 'send':
      case 'confirm':
      case 'confirm_send':
	self::$nID=(int)$_GET['nID'];
	self::$nInfo=self::load_db_values(self::$nID);
	self::load_module();
	return tep_get_include_contents(self::$code.'.'.self::$action);
      break;
      default:
	self::tep_get_list();
	return tep_get_include_contents(self::$code.'.listing');
    }
  }


  /** public static InterfacedTJsonS */

  private static function get_item_action($newsletters){
    return '<span class="view fils fleft">'.
	      '<a class="buttonimg fancy" href="' . tep_href_link(self::FILENAME, 'nID=' . $newsletters['newsletters_id'] . '&amp;action=preview') . '">' . tep_image(DIR_WS_ICONS . 'preview.gif', ICON_PREVIEW) . '</a>'.
	      (($newsletters['locked'] > 0 && $newsletters['status']!=2) ?'<a class="button"  href="' . tep_href_link(self::FILENAME,  'nID=' . $newsletters['newsletters_id'] . '&amp;action=send') . '"  class="fancytext iframe">' . IMAGE_SEND . '</a>' : '').
	    '</span>'.
	    '<span class="view fils fright">'.
	      '<a class="buttonimg" href="' . tep_href_link(self::FILENAME, 'nID=' . $newsletters['newsletters_id'] . '&amp;action=edit') . '">' . tep_image(DIR_WS_ICONS.'icon_edit.png', IMAGE_EDIT) . '</a>'.
	      '<a class="buttonimg fancyView " href="' . tep_href_link(self::FILENAME, 'nID=' . $newsletters['newsletters_id'] . '&amp;action=delete') . '">' . tep_image(DIR_WS_ICONS.'icon_delete.png', IMAGE_DELETE) . '</a>  '.
            '</span>';
  }

  private static function get_item_locked($newsletters){
    if ($newsletters['locked'] > 0)
      return '<a  class="buttonimg" href="' . tep_href_link(self::FILENAME, 'nID=' . $newsletters['newsletters_id'] . '&amp;action=unlock') . '">' . tep_image(DIR_WS_ICONS .'locked.gif', ICON_LOCKED) . '</a>';
    else
      return '<a  class="buttonimg" href="' . tep_href_link(self::FILENAME, 'nID=' . $newsletters['newsletters_id'] . '&amp;action=lock') . '">' . tep_image(DIR_WS_ICONS .'unlocked.gif', ICON_UNLOCKED) . '</a>';
  }

  private static function get_item_status($newsletters){
// print_r($newsletters);
    $var=(int)$newsletters['status'] ;
    if ($var == 2)
      return tep_image(DIR_WS_ICONS . 'tick.gif', ICON_TICK);
    elseif ($var == 1)
      return __('reload');
    else
      return tep_image(DIR_WS_ICONS . 'cross.gif', ICON_CROSS);

  }

  private static function emptyResult(){
    $li=array();
    foreach(self::tep_get_modele() as $k=>$v) $li[$k]='&nbsp;';
    return $li;
  }

  public static function tep_get_modele(){
    return array( 0 =>false,
		  'title' =>true,
                  'content'=>true,
                  'module'=>true,
		  'status'=>true,
                  'locked'=>true,
                  'nbr_send'=>true,
                  'action'=>false,
                );
  }

  public static function tep_get_list($page=1,$rowbyp=10,$sOrder='',$sWhere='',$options=''){
    global $query_numrows;

    $DB=Database::getInstance();

    $query_raw ="select newsletters_id, title, length(content) as content_length, module, date_added, date_sent, status, locked,nbr_send from " . TABLE_NEWSLETTERS . " ".$sWhere." ORDER BY ".((!empty($sOrder)) ? $sOrder : " date_added DESC ");
    $split = new splitPageResults($page, $rowbyp, $query_raw, $query_numrows);

    $query = $DB->query($query_raw);

    while ($item = $query->fetchAssoc() ) {
      $item[0]=$item['newsletters_id'];
      $item['status']=strip_tags(self::get_item_status($item));
      $item['locked']=self::get_item_locked($item);
      $item['action']=self::get_item_action($item);
      $item['content']=$item['content_length'];
      self::$list[]=$item;
    }

    $li=$res=array();
    foreach(self::$list as $item){
      foreach(self::tep_get_modele() as $k=>$v) $li[$k]=(tep_not_null($item[$k]))?$item[$k]:'&nbsp;';
      $res[]=$li;
    }
    if(count($res)==0) $res[]=self::emptyResult();
    return $res;
  }


 /** static InterfacedInnerHtml */

  public static function detail_row_page($id){
//     self::init();
    self::$nID=(int)$id;
    self::$nInfo=self::load_db_values((int)$id);
    self::load_module();
    return tep_get_include_contents(__CLASS__.'.inline');
  }


/** Interface module */

  public function check() { return false; }
  public function install() { return false; }
  public function remove() { return false;  }
  public function keys() { return false; }


/** specific modules */

  /**
    List les modules present dans /modules/neswletters/
    @return array
  */
  public static function list_module_newsletters(){
    $file_extension = '.php';
    $directory_array = array();
    if ($dir = dir(DIR_WS_MODULES . 'newsletters/')) {
      while ($file = $dir->read()) {
        if (!is_dir(DIR_WS_MODULES . 'newsletters/' . $file)) {
          if (substr($file, strrpos($file, '.')) == $file_extension) {
            $directory_array[] = $file;
          }
        }
      }
      sort($directory_array);
      $dir->close();
    }

    for ($i=0, $n=sizeof($directory_array); $i<$n; $i++) {
      $modules_array[] = array('id' => substr($directory_array[$i], 0, strrpos($directory_array[$i], '.')), 'text' => substr($directory_array[$i], 0, strrpos($directory_array[$i], '.')));
    }
    return $modules_array;
  }

  /**
    Chargeur de module
  */
  private static function load_module(){
    global $language;
    include(DIR_WS_LANGUAGES . $language . '/modules/newsletters/' . self::$nInfo->module . '.php');
    if(!class_exists(self::$nInfo->module))include(DIR_WS_MODULES . 'newsletters/' . self::$nInfo->module . '.php');
    $module_name = self::$nInfo->module;
    self::$module = new $module_name(self::$nID,self::$nInfo->title, self::$nInfo->content);

    self::$uhtml_received_count = self::$module->count_sended;
    self::$uhtml_want_count = self::$module->count;
  }


  /**
    @packageoriginal Ultimate Html Email
    @author oscim <mail a@oscim.fr /><web http://www.oscim.fr />
    barre progression d'envoi des email
  */
  public static function draw_progress_bar($percent, $width, $height){
    global $uhtml_received_count, $uhtml_want_count;
    ?>
    <p><span style="font-size:15pt;">Progress - <?php echo $percent; ?>%</span><br />
    <span style="font-size:12pt;"><?php echo $uhtml_received_count; ?> of <?php echo $uhtml_want_count ?> emails are sent.</span></p>
    <div align="left" style="width:<?php echo $width; ?>px; height:<?php echo $height; ?>px; border:2px solid #000000; padding:0px;">
	    <div style="width:<?php echo (int)$percent/100*$width; ?>px; height:<?php echo $height; ?>px; background-color:#79973F;"></div>
    </div>
    <?php
  }

  /**
    Nombre d'envoi a effectué
  */
  public function count_send(){
    $DB=Database::getInstance();
    $mail_query = $DB->query("SELECT COUNT(*) as count FROM " . TABLE_CUSTOMERS . " WHERE customers_newsletter = '1'  ");
    $mail = $mail_query->fetchAssoc();
    return $mail['count'];
  }

  /**
    Nombre d'envoi deja effetué
    @a int newsletters_id
  */
  public function count_sended_ok($newsletters_id, $code){
    $DB=Database::getInstance();
    $mail_query = $DB->query($sql="SELECT COUNT(*) AS count FROM ".TABLE_NEWSLETTERS_SENT." WHERE newsletters_id = '" . $newsletters_id. "' AND module_type='".$code."' ");
    $mail = $mail_query->fetchAssoc();
    return $mail['count'];
  }
}

?>